VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5310
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   7875
   LinkTopic       =   "Form1"
   ScaleHeight     =   5310
   ScaleWidth      =   7875
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdReport 
      Caption         =   "Report"
      Height          =   315
      Left            =   2400
      TabIndex        =   4
      Top             =   0
      Width           =   735
   End
   Begin VB.DirListBox dirSearch 
      Height          =   2790
      Left            =   0
      TabIndex        =   3
      Top             =   360
      Width           =   2175
   End
   Begin VB.DriveListBox drvSearch 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.FileListBox filSearch 
      Height          =   2625
      Left            =   0
      Pattern         =   "*.vbp"
      TabIndex        =   1
      Top             =   3240
      Width           =   2175
   End
   Begin VB.TextBox txtReport 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2175
      Left            =   2280
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   360
      Width           =   5055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const TOKEN_FORM = "Form="
Private Const TOKEN_MODULE = "Module="
Private Const TOKEN_CLASS = "Class="
Private Const TOKEN_END = "End"
Private Const TOKEN_BEGIN = "Begin"
Private Const TOKEN_PRIVATE = "Private "
Private Const TOKEN_PUBLIC = "Public "
Private Const TOKEN_SUB = "Sub "
Private Const TOKEN_FUNCTION = "Function "
Private Const TOKEN_PROPERTY = "Property "

Private Const MAX_PATH = 260
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

'Private Const ERROR_NO_MORE_FILES = 18&
Private Const INVALID_HANDLE_VALUE = -1
Private Const DDL_DIRECTORY = &H10

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1

Private Const ERROR_FILE_NOT_FOUND = 2&
Private Const ERROR_PATH_NOT_FOUND = 3&
Private Const ERROR_BAD_FORMAT = 11&
Private Const SE_ERR_ACCESSDENIED = 5            '  access denied
Private Const SE_ERR_ASSOCINCOMPLETE = 27
Private Const SE_ERR_DDEBUSY = 30
Private Const SE_ERR_DDEFAIL = 29
Private Const SE_ERR_DDETIMEOUT = 28
Private Const SE_ERR_DLLNOTFOUND = 32
Private Const SE_ERR_FNF = 2                     '  file not found
Private Const SE_ERR_NOASSOC = 31
Private Const SE_ERR_OOM = 8                     '  out of memory
Private Const SE_ERR_PNF = 3                     '  path not found
Private Const SE_ERR_SHARE = 26
' Return true if the line contains a comment.
Private Function ContainsComment(ByVal new_line As String) As Boolean
Dim i As Integer
Dim quotes_open As Boolean

    ' Assume we will find a comment.
    ContainsComment = True

    quotes_open = False
    For i = 1 To Len(new_line)
        Select Case Mid$(new_line, i, 1)
            Case """"
                quotes_open = Not quotes_open
            Case "'"
                If Not quotes_open Then Exit Function
        End Select
    Next i

    ' No comment.
    ContainsComment = False
End Function

' Process all Visual Basic project below the directory.
Private Sub ProcessFiles(ByVal start_dir As String, ByRef num_projects As Long, ByRef num_forms As Long, ByRef num_modules As Long, ByRef num_classes As Long, ByRef num_controls As Long, ByRef num_lines As Long, ByRef num_subs As Long, ByRef num_functions As Long, ByRef num_properties As Long, ByRef num_comments As Long)

Const MAXDWORD = 2 ^ 32

Dim dir_names() As String
Dim num_dirs As Integer
Dim i As Integer
Dim fname As String
Dim new_files As String
Dim attr As Integer
Dim search_handle As Long
Dim file_data As WIN32_FIND_DATA
Dim file_size As Double

    DoEvents

    ' Get the project files in this directory.
    ' Get the first file.
    search_handle = FindFirstFile( _
        start_dir & "*.vbp", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            fname = file_data.cFileName
            fname = Left$(fname, InStr(fname, Chr$(0)) - 1)
            fname = start_dir & fname

            ' Process this project.
            ReportOnProject fname, _
                num_projects, _
                num_forms, _
                num_modules, _
                num_classes, _
                num_controls, _
                num_lines, _
                num_subs, _
                num_functions, _
                num_properties, _
                num_comments

            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search handle.
        FindClose search_handle
    End If

    ' Optionally display the new list here.

    ' Get the list of subdirectories.
    search_handle = FindFirstFile( _
        start_dir & "*.*", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            If file_data.dwFileAttributes And DDL_DIRECTORY Then
                fname = file_data.cFileName
                fname = Left$(fname, InStr(fname, Chr$(0)) - 1)
                If fname <> "." And fname <> ".." Then
                    num_dirs = num_dirs + 1
                    ReDim Preserve dir_names(1 To num_dirs)
                    dir_names(num_dirs) = fname
                End If
            End If
            
            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search handle.
        FindClose search_handle
    End If

    ' Search the subdirectories.
    For i = 1 To num_dirs
        ProcessFiles start_dir & dir_names(i) & "\", _
            num_projects, _
            num_forms, _
            num_modules, _
            num_classes, _
            num_controls, _
            num_lines, _
            num_subs, _
            num_functions, _
            num_properties, _
            num_comments
    Next i
End Sub
' Report on projects below this directory.
Private Sub cmdReport_Click()
Dim num_projects As Long
Dim num_forms As Long
Dim num_modules As Long
Dim num_classes As Long
Dim num_controls As Long
Dim num_lines As Long
Dim num_subs As Long
Dim num_functions As Long
Dim num_properties As Long
Dim num_comments As Long
Dim dir_path As String
Dim txt As String

    txtReport.Text = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Search the directory and its
    ' subdirectories for project files.
    dir_path = dirSearch.Path
    If Right$(dir_path, 1) <> "\" Then dir_path = dir_path & "\"
    ProcessFiles dir_path, _
        num_projects, _
        num_forms, _
        num_modules, _
        num_classes, _
        num_controls, _
        num_lines, _
        num_subs, _
        num_functions, _
        num_properties, _
        num_comments

    ' Display the results.
    ' Return the result.
    txt = ""
    txt = txt & "Projects:         " & Format$(num_projects, "@@@@@@@") & vbCrLf
    txt = txt & "Forms:            " & Format$(num_forms, "@@@@@@@") & vbCrLf
    txt = txt & "Modules:          " & Format$(num_modules, "@@@@@@@") & vbCrLf
    txt = txt & "Classes:          " & Format$(num_classes, "@@@@@@@") & vbCrLf
    txt = txt & "Total Controls:   " & Format$(num_controls, "@@@@@@@") & vbCrLf
    txt = txt & "Total Lines:      " & Format$(num_lines, "@@@@@@@") & vbCrLf
    txt = txt & "Total Subs:       " & Format$(num_subs, "@@@@@@@") & vbCrLf
    txt = txt & "Total Functions:  " & Format$(num_functions, "@@@@@@@") & vbCrLf
    txt = txt & "Total Properties: " & Format$(num_properties, "@@@@@@@") & vbCrLf
    txt = txt & "Total Comments:   " & Format$(num_comments, "@@@@@@@") & vbCrLf
    txtReport.Text = txt
    txtReport.SelStart = 0
    txtReport.SelLength = 0

    Screen.MousePointer = vbDefault
End Sub

Private Sub drvSearch_Change()
    'On Error GoTo DriveError
    dirSearch.Path = drvSearch.Drive
    Exit Sub

DriveError:
    drvSearch.Drive = dirSearch.Path
    Exit Sub
End Sub
Private Sub dirSearch_Change()
    filSearch.Path = dirSearch.Path
End Sub

' Count the rest of the lines.
Private Sub CountTheRest(ByVal fnum As Integer, ByRef num_lines As Long, ByRef num_subs As Long, ByRef num_functions As Long, ByRef num_properties As Long, ByRef num_comments As Long)
Dim new_line As String

    ' Examine the lines.
    Do While Not EOF(fnum)
        Line Input #fnum, new_line
        num_lines = num_lines + 1

        If ContainsComment(new_line) Then num_comments = num_comments + 1

        ' Remove leading Private or Public.
        If PrefixMatches(new_line, TOKEN_PRIVATE) Then
            new_line = Mid$(new_line, Len(TOKEN_PRIVATE) + 1)
        ElseIf PrefixMatches(new_line, TOKEN_PUBLIC) Then
            new_line = Mid$(new_line, Len(TOKEN_PUBLIC) + 1)
        End If

        ' See if we got anything interesting.
        If PrefixMatches(new_line, TOKEN_SUB) Then
            num_subs = num_subs + 1
        ElseIf PrefixMatches(new_line, TOKEN_FUNCTION) Then
            num_functions = num_functions + 1
        ElseIf PrefixMatches(new_line, TOKEN_PROPERTY) Then
            num_properties = num_properties + 1
        End If
    Loop
End Sub

' Return a report about a form.
Private Function ReportOnForm(ByVal project_dir As String, ByVal form_file As String, ByRef total_lines As Long, ByRef total_controls As Long, ByRef total_subs As Long, ByRef total_functions As Long, ByRef total_properties As Long, ByRef total_comments As Long) As String
Dim txt As String
Dim fnum As Integer
Dim new_line As String
Dim begins_open As Long
Dim num_controls As Long
Dim num_lines As Long
Dim num_functions As Long
Dim num_subs As Long
Dim num_properties As Long
Dim num_comments As Long

    txt = "Form:       " & form_file & vbCrLf

    fnum = FreeFile
    On Error Resume Next
    Open project_dir & form_file For Input As fnum
    If Err.Number <> 0 Then
        txt = txt & "*** Error " & _
            Format$(Err.Number) & _
            " opening form file " & _
            project_dir & form_file & _
            vbCrLf & Err.Description
        ReportOnForm = txt
        Exit Function
    End If
    On Error GoTo 0

    ' Find the "Begin VB.Form" line.
    Do While Not EOF(fnum)
        Line Input #fnum, new_line
        new_line = Trim$(new_line)
        If PrefixMatches(new_line, TOKEN_BEGIN) _
            Then Exit Do
    Loop

    ' Search for the corresponding End.
    begins_open = 1
    Do While Not EOF(fnum)
        Line Input #fnum, new_line
        new_line = Trim$(new_line)
        If PrefixMatches(new_line, TOKEN_BEGIN) Then
            num_controls = num_controls + 1
            begins_open = begins_open + 1
        ElseIf PrefixMatches(new_line, TOKEN_END) Then
            begins_open = begins_open - 1
            If begins_open < 1 Then Exit Do
        End If
    Loop

    ' Count the remaining lines.
    CountTheRest fnum, num_lines, num_subs, num_functions, num_properties, num_comments

    ' Close the form file.
    Close fnum

    total_lines = total_lines + num_lines
    total_controls = total_controls + num_controls
    total_subs = total_subs + num_subs
    total_functions = total_functions + num_functions
    total_properties = total_properties + num_properties
    total_comments = total_comments + num_comments
    ReportOnForm = txt & _
        "Lines:      " & Format$(num_lines) & vbCrLf & _
        "Controls:   " & Format$(num_controls) & vbCrLf & _
        "Subs:       " & Format$(num_subs) & vbCrLf & _
        "Functions:  " & Format$(num_functions) & vbCrLf & _
        "Properties: " & Format$(num_properties) & vbCrLf & _
        "Comments:   " & Format$(num_comments) & vbCrLf
End Function

' Return a report about a BAS or CLS module.
Private Function ReportOnModule(ByVal project_dir As String, ByVal module_file As String, ByVal module_type As String, ByRef total_lines As Long, ByRef total_controls As Long, ByRef total_subs As Long, ByRef total_functions As Long, ByRef total_properties As Long, ByRef total_comments As Long) As String
Dim txt As String
Dim fnum As Integer
Dim new_line As String
Dim num_lines As Long
Dim num_functions As Long
Dim num_subs As Long
Dim num_properties As Long
Dim num_comments As Long

    module_type = module_type & ":"
    txt = Format$(module_type, "!@@@@@@@@@@@@") & module_file & vbCrLf

    fnum = FreeFile
    On Error Resume Next
    Open project_dir & module_file For Input As fnum
    If Err.Number <> 0 Then
        txt = txt & "*** Error " & _
            Format$(Err.Number) & _
            " opening module file " & _
            project_dir & module_file & _
            vbCrLf & Err.Description
        ReportOnModule = txt
        Exit Function
    End If
    On Error GoTo 0

    ' Count all the lines.
    CountTheRest fnum, num_lines, num_subs, num_functions, num_properties, num_comments

    ' Close the module file.
    Close fnum

    total_lines = total_lines + num_lines
    total_subs = total_subs + num_subs
    total_functions = total_functions + num_functions
    total_properties = total_properties + num_properties
    total_comments = total_comments + num_comments
    ReportOnModule = txt & _
        "Lines:      " & Format$(num_lines) & vbCrLf & _
        "Subs:       " & Format$(num_subs) & vbCrLf & _
        "Functions:  " & Format$(num_functions) & vbCrLf & _
        "Properties: " & Format$(num_properties) & vbCrLf & _
        "Comments:   " & Format$(num_comments) & vbCrLf
End Function

' Return True of txt begins with prefix.
Private Function PrefixMatches(ByVal txt As String, ByVal prefix As String) As Boolean
    PrefixMatches = (Left$(txt, Len(prefix)) = prefix)
End Function

' Return a report on a project.
Private Sub ReportOnProject(ByVal project_file As String, ByRef num_projects As Long, ByRef num_forms As Long, ByRef num_modules As Long, ByRef num_classes As Long, ByRef num_controls As Long, ByRef num_lines As Long, ByRef num_subs As Long, ByRef num_functions As Long, ByRef num_properties As Long, ByRef num_comments As Long)
Dim project_dir As String
Dim fnum As Integer
Dim new_line As String
Dim project_forms As Collection
Dim project_modules As Collection
Dim project_classes As Collection
Dim i As Integer

    num_projects = num_projects + 1

    ' Get the project directory.
    project_dir = Left$(project_file, InStrRev(project_file, "\"))

    ' Process the project file.
    fnum = FreeFile
    Open project_file For Input As fnum

    Set project_forms = New Collection
    Set project_modules = New Collection
    Set project_classes = New Collection

    ' Read the lines in the project file.
    Do While Not EOF(fnum)
        ' Read a line.
        Line Input #fnum, new_line

        ' See what this line is.
        If PrefixMatches(new_line, TOKEN_FORM) Then
            ' It's a form.
            project_forms.Add Mid$(new_line, Len(TOKEN_FORM) + 1)
        ElseIf PrefixMatches(new_line, TOKEN_MODULE) Then
            ' It's a module.
            project_modules.Add Trim$(Mid$(new_line, InStr(new_line, ";") + 1))
        ElseIf PrefixMatches(new_line, TOKEN_CLASS) Then
            ' It's a class.
            project_classes.Add Trim$(Mid$(new_line, InStr(new_line, ";") + 1))
        End If
    Loop

    ' Close the project file.
    Close fnum

    ' Process the forms.
    num_forms = num_forms + project_forms.Count
    For i = 1 To project_forms.Count
        ReportOnForm project_dir, project_forms(i), num_lines, num_controls, num_subs, num_functions, num_properties, num_comments
    Next i

    ' Process the modules.
    num_modules = num_modules + project_modules.Count
    For i = 1 To project_modules.Count
        ReportOnModule project_dir, project_modules(i), num_lines, num_controls, num_subs, num_functions, num_properties, num_comments, num_comments
    Next i

    ' Process the classes.
    num_classes = num_classes + project_classes.Count
    For i = 1 To project_classes.Count
        ReportOnModule project_dir, project_classes(i), num_lines, num_controls, num_subs, num_functions, num_properties, num_comments, num_comments
    Next i
End Sub
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    hgt = (ScaleHeight - dirSearch.Top) / 2
    If hgt < 120 Then hgt = 120
    dirSearch.Height = hgt
    filSearch.Move 0, dirSearch.Top + hgt, filSearch.Width, hgt

    wid = ScaleWidth - txtReport.Left
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - txtReport.Top
    If hgt < 120 Then hgt = 120

    txtReport.Move txtReport.Left, txtReport.Top, wid, hgt
End Sub

